SystemOrganization addCategory: #'Stack-Exercise'!

Object subclass: #GeneralStack
	instanceVariableNames: 'datos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

GeneralStack class
	instanceVariableNames: 'datos'!

GeneralStack class
	instanceVariableNames: 'datos'!

GeneralStack subclass: #EmptyStack
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!EmptyStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 20:53'!
isEmpty
	"comment stating purpose of message"

	| temporary variable names |
	^true! !

!EmptyStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 20:48'!
pop
	"comment stating purpose of message"

	| temporary variable names |
	     self error:'Stack is empty'! !

!EmptyStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 21:21'!
push: anObject
	"comment stating purpose of message"

	^ (NonEmptyStack new) push: anObject.! !

!EmptyStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 20:57'!
size
	"comment stating purpose of message"

	| temporary variable names |
	^0! !

!EmptyStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 20:48'!
top
	"comment stating purpose of message"

	| temporary variable names |
	     self error:'Stack is empty'! !

!GeneralStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 21:07'!
initialize
	"comment stating purpose of message"

	| temporary variable names |
	^ EmptyStack new! !

!GeneralStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 21:13'!
isEmpty
	"comment stating purpose of message"

 self subclassResponsibility! !

!GeneralStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 21:13'!
pop
	

	| temporary variable names |
	  self subclassResponsibility! !

!GeneralStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 21:14'!
push: anObject
	"comment stating purpose of message"

 self subclassResponsibility! !

!GeneralStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 21:15'!
size
	"comment stating purpose of message"

	| temporary variable names |
	  self subclassResponsibility! !

!GeneralStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 21:16'!
top

 self subclassResponsibility! !

GeneralStack subclass: #NonEmptyStack
	instanceVariableNames: 'misdatos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!NonEmptyStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 21:09'!
isEmpty
	"comment stating purpose of message"

	| temporary variable names |
	^misdatos isEmpty! !

!NonEmptyStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 21:11'!
pop
	

	| temporary variable names |
	  ^misdatos pop! !

!NonEmptyStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 21:14'!
push: anObject
	"comment stating purpose of message"

	| temporary variable names |
    misdatos := OrderedCollection new.
    misdatos addFirst: anObject.
	^ anObject.! !

!NonEmptyStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 21:15'!
size
	"comment stating purpose of message"

	| temporary variable names |
	^misdatos size! !

!NonEmptyStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 21:16'!
top

^ misdatos first! !

Object subclass: #OOStack
	instanceVariableNames: 'datos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStack class methodsFor: 'error descriptions' stamp: 'HernanWilkinson 5/7/2012 11:51'!
stackEmptyErrorDescription
	
	^ 'Stack is empty'! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 19:31'!
initialize
	"comment stating purpose of message"

	| temporary variable names |
	datos := OrderedCollection new! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 19:29'!
isEmpty
	"comment stating purpose of message"

	| temporary variable names |
	^datos isEmpty! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 20:22'!
pop
	"comment stating purpose of message"

	| temporary variable names |
	     (self size = 0) ifTrue: [ self error:'Stack is empty' ] ifFalse:[^datos  removeFirst ]
	
		! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 19:38'!
push: anObject
	"comment stating purpose of message"

	| temporary variable names |
    datos addFirst: anObject.
	^ anObject.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 19:49'!
size
	"comment stating purpose of message"

	| temporary variable names |
	^datos size! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'Max 5/14/2012 20:23'!
top
	"comment stating purpose of message"

	| temporary variable names |
	
	
     (self size = 0) ifTrue: [ self error:'Stack is empty' ] ifFalse:[^ datos first ]! !

TestCase subclass: #OOStackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test01StackShouldBeEmptyWhenCreated

	| stack |
	
	stack := OOStack new.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test02PushAddElementsToTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	
	self deny: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:31'!
test03PopRemovesElementsFromTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/8/2012 08:20'!
test04PopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	stack push: pushedObject.
	
	self assert: stack pop = pushedObject! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:33'!
test05StackBehavesLIFO

	| stack firstPushedObject secondPushedObject |
	
	stack := OOStack new.
	firstPushedObject := 'First'.
	secondPushedObject := 'Second'.
	
	stack push: firstPushedObject.
	stack push: secondPushedObject.
	
	self assert: stack pop = secondPushedObject.
	self assert: stack pop = firstPushedObject.
	self assert: stack isEmpty 
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:35'!
test06TopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack top = pushedObject.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:36'!
test07TopDoesNotRemoveObjectFromStack

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack size = 1.
	stack top.
	self assert: stack size = 1.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:38'!
test08CanNotPopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:39'!
test09CanNotTopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack top ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !
